=== debian/changelog ===
freedv (1.8.7-1) unstable; urgency=medium

  * New upstream release.

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 20 Jan 2023 21:47:50 -0500

freedv (1.8.5-1) unstable; urgency=medium

  * New upstream release.
    Update FreeDV configuration defaults to improve first-time usability.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 10 Dec 2022 15:45:18 -0500

freedv (1.8.4-1) unstable; urgency=medium

  [ Christoph Berg ]
  * Update watch file to look at github tags.

  [ A. Maitland Bottoms ]
  * New upstream release.

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 04 Nov 2022 10:17:11 -0400

freedv (1.8.3.1-3) unstable; urgency=medium

  * Team upload.
  * Update build-dep for wxWidgets to 3.2 (Closes: #1019794)
  * Update lintian-overrides

 -- tony mancill <tmancill@debian.org>  Fri, 16 Sep 2022 22:45:43 -0700

freedv (1.8.3.1-2) unstable; urgency=medium

  * Set USE_PULSEAUDIO correctly without gbp changing it. (Closes: 1006419)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 27 Aug 2022 16:39:51 -0400

freedv (1.8.3.1-1) unstable; urgency=medium

  * New upstream release.
  * Set USE_PULSEAUDIO correctly (Closes: 1006419)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 27 Aug 2022 16:24:16 -0400
