=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --builddir=Build --build-system=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
	 -DDEB_VERSION=$(DEB_VERSION) -DCMAKE_BUILD_TYPE=RelWithDebInfo -DUSE_STATIC_CODEC2=False \
	 -DUSE_STATIC_SPEEXDSP=False -DUSE_PULSEAUDIO=True

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/freedv/usr/share/freedv-gui
