=== src/CMakeLists.txt ===
--- 
+++ 
@@ -31,9 +31,6 @@
     topFrame.h
     version.h
     osx_interface.h
-    pskreporter.cpp
-    pskreporter.h
-    udp.cpp
     util.cpp
     eq.cpp
     voicekeyer.cpp
@@ -41,6 +38,8 @@
     ongui.cpp
     freedv_interface.cpp
     freedv_interface.h        
+    wxListViewComboPopup.cpp
+    wxListViewComboPopup.h
 )
 
 set(FREEDV_SOURCES_OSX
@@ -54,6 +53,7 @@
 # Compile FreeDV components
 add_subdirectory(audio)
 add_subdirectory(pipeline)
+add_subdirectory(reporting)
 add_subdirectory(sox)
 
 # WIN32 is needed for Windows GUI apps and is ignored for UNIX like systems.
@@ -79,9 +79,9 @@
 
 # Link imported or build tree targets.
 if(APPLE)
-target_link_libraries(FreeDV fdv_audio fdv_audio_pipeline fdv_sox lpcnetfreedv codec2)
+target_link_libraries(FreeDV fdv_audio fdv_audio_pipeline fdv_reporting fdv_sox lpcnetfreedv codec2)
 else(APPLE)
-target_link_libraries(freedv fdv_audio fdv_audio_pipeline fdv_sox lpcnetfreedv codec2)
+target_link_libraries(freedv fdv_audio fdv_audio_pipeline fdv_reporting fdv_sox lpcnetfreedv codec2)
 endif(APPLE)
 
 # Add build dependencies for internally built external libraries.
