=== src/sox/CMakeLists.txt ===
add_library(fdv_sox STATIC
    band.h
    biquad.c
    biquads.c
    biquad.h
    effects.c
    effects.h
    effects_i.c
    effects_i_dsp.c
    fft4g.c
    formats.c
    formats_i.c
    libsox.c
    sox.h
    sox_i.h
    soxomp.h
    util.c
    util.h
    vol.c
    xmalloc.h
    xmalloc.c)
