=== debian/changelog ===
freedv (1.8.11-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:21:09 +0000

freedv (1.8.11-1build3) noble; urgency=high

  * No change rebuild against libwxbase3.2-1t64, libwxgtk3.2-1t64,
    libhamlib4t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:04:56 +0100

freedv (1.8.11-1build2) mantic; urgency=medium

  * Rebuild against new libcodec2-1.2.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 19 Aug 2023 00:23:41 +0200

freedv (1.8.11-1build1) mantic; urgency=medium

  * Rebuild against new libcodec2-1.1.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 18 Jul 2023 08:21:12 +0200

freedv (1.8.11-1) unstable; urgency=medium

  * New upstream release.

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 11 Jul 2023 13:10:52 -0400
