=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,8 @@
 override_dh_auto_configure:
 	dh_auto_configure --buildsystem=cmake -- \
 	 -DDEB_VERSION=$(DEB_VERSION) -DCMAKE_BUILD_TYPE=RelWithDebInfo -DUSE_STATIC_CODEC2=False \
-	 -DUSE_STATIC_SPEEXDSP=False -DUSE_PULSEAUDIO=True
+	 -DUSE_STATIC_SPEEXDSP=False -DUSE_PULSEAUDIO=True \
+	 -DUSE_SIOCLIENT=OFF
 
 override_dh_auto_install:
 	dh_auto_install
